package apds

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// ListSurveyResourceByMigrationGroups invokes the apds.ListSurveyResourceByMigrationGroups API synchronously
func (client *Client) ListSurveyResourceByMigrationGroups(request *ListSurveyResourceByMigrationGroupsRequest) (response *ListSurveyResourceByMigrationGroupsResponse, err error) {
	response = CreateListSurveyResourceByMigrationGroupsResponse()
	err = client.DoAction(request, response)
	return
}

// ListSurveyResourceByMigrationGroupsWithChan invokes the apds.ListSurveyResourceByMigrationGroups API asynchronously
func (client *Client) ListSurveyResourceByMigrationGroupsWithChan(request *ListSurveyResourceByMigrationGroupsRequest) (<-chan *ListSurveyResourceByMigrationGroupsResponse, <-chan error) {
	responseChan := make(chan *ListSurveyResourceByMigrationGroupsResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.ListSurveyResourceByMigrationGroups(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// ListSurveyResourceByMigrationGroupsWithCallback invokes the apds.ListSurveyResourceByMigrationGroups API asynchronously
func (client *Client) ListSurveyResourceByMigrationGroupsWithCallback(request *ListSurveyResourceByMigrationGroupsRequest, callback func(response *ListSurveyResourceByMigrationGroupsResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *ListSurveyResourceByMigrationGroupsResponse
		var err error
		defer close(result)
		response, err = client.ListSurveyResourceByMigrationGroups(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// ListSurveyResourceByMigrationGroupsRequest is the request struct for api ListSurveyResourceByMigrationGroups
type ListSurveyResourceByMigrationGroupsRequest struct {
	*requests.RoaRequest
	Body string `position:"Query" name:"body"`
}

// ListSurveyResourceByMigrationGroupsResponse is the response struct for api ListSurveyResourceByMigrationGroups
type ListSurveyResourceByMigrationGroupsResponse struct {
	*responses.BaseResponse
	Code    string `json:"Code" xml:"Code"`
	Error   string `json:"Error" xml:"Error"`
	Success bool   `json:"Success" xml:"Success"`
	Data    string `json:"Data" xml:"Data"`
}

// CreateListSurveyResourceByMigrationGroupsRequest creates a request to invoke ListSurveyResourceByMigrationGroups API
func CreateListSurveyResourceByMigrationGroupsRequest() (request *ListSurveyResourceByMigrationGroupsRequest) {
	request = &ListSurveyResourceByMigrationGroupsRequest{
		RoaRequest: &requests.RoaRequest{},
	}
	request.InitWithApiInfo("apds", "2022-03-31", "ListSurveyResourceByMigrationGroups", "/okss-services/migration-group/get-survey-resource", "", "")
	request.Method = requests.POST
	return
}

// CreateListSurveyResourceByMigrationGroupsResponse creates a response to parse from ListSurveyResourceByMigrationGroups response
func CreateListSurveyResourceByMigrationGroupsResponse() (response *ListSurveyResourceByMigrationGroupsResponse) {
	response = &ListSurveyResourceByMigrationGroupsResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
