package ens

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// RollbackWorkflow invokes the ens.RollbackWorkflow API synchronously
func (client *Client) RollbackWorkflow(request *RollbackWorkflowRequest) (response *RollbackWorkflowResponse, err error) {
	response = CreateRollbackWorkflowResponse()
	err = client.DoAction(request, response)
	return
}

// RollbackWorkflowWithChan invokes the ens.RollbackWorkflow API asynchronously
func (client *Client) RollbackWorkflowWithChan(request *RollbackWorkflowRequest) (<-chan *RollbackWorkflowResponse, <-chan error) {
	responseChan := make(chan *RollbackWorkflowResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.RollbackWorkflow(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// RollbackWorkflowWithCallback invokes the ens.RollbackWorkflow API asynchronously
func (client *Client) RollbackWorkflowWithCallback(request *RollbackWorkflowRequest, callback func(response *RollbackWorkflowResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *RollbackWorkflowResponse
		var err error
		defer close(result)
		response, err = client.RollbackWorkflow(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// RollbackWorkflowRequest is the request struct for api RollbackWorkflow
type RollbackWorkflowRequest struct {
	*requests.RpcRequest
	WorkflowIds *[]string `position:"Query" name:"WorkflowIds"  type:"Json"`
}

// RollbackWorkflowResponse is the response struct for api RollbackWorkflow
type RollbackWorkflowResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
}

// CreateRollbackWorkflowRequest creates a request to invoke RollbackWorkflow API
func CreateRollbackWorkflowRequest() (request *RollbackWorkflowRequest) {
	request = &RollbackWorkflowRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Ens", "2017-11-10", "RollbackWorkflow", "ens", "openAPI")
	request.Method = requests.POST
	return
}

// CreateRollbackWorkflowResponse creates a response to parse from RollbackWorkflow response
func CreateRollbackWorkflowResponse() (response *RollbackWorkflowResponse) {
	response = &RollbackWorkflowResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
