package paifeaturestore

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// CreateModelFeatureTrainingSetFGTable invokes the paifeaturestore.CreateModelFeatureTrainingSetFGTable API synchronously
func (client *Client) CreateModelFeatureTrainingSetFGTable(request *CreateModelFeatureTrainingSetFGTableRequest) (response *CreateModelFeatureTrainingSetFGTableResponse, err error) {
	response = CreateCreateModelFeatureTrainingSetFGTableResponse()
	err = client.DoAction(request, response)
	return
}

// CreateModelFeatureTrainingSetFGTableWithChan invokes the paifeaturestore.CreateModelFeatureTrainingSetFGTable API asynchronously
func (client *Client) CreateModelFeatureTrainingSetFGTableWithChan(request *CreateModelFeatureTrainingSetFGTableRequest) (<-chan *CreateModelFeatureTrainingSetFGTableResponse, <-chan error) {
	responseChan := make(chan *CreateModelFeatureTrainingSetFGTableResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.CreateModelFeatureTrainingSetFGTable(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// CreateModelFeatureTrainingSetFGTableWithCallback invokes the paifeaturestore.CreateModelFeatureTrainingSetFGTable API asynchronously
func (client *Client) CreateModelFeatureTrainingSetFGTableWithCallback(request *CreateModelFeatureTrainingSetFGTableRequest, callback func(response *CreateModelFeatureTrainingSetFGTableResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *CreateModelFeatureTrainingSetFGTableResponse
		var err error
		defer close(result)
		response, err = client.CreateModelFeatureTrainingSetFGTable(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// CreateModelFeatureTrainingSetFGTableRequest is the request struct for api CreateModelFeatureTrainingSetFGTable
type CreateModelFeatureTrainingSetFGTableRequest struct {
	*requests.RoaRequest
	ModelFeatureId string `position:"Path" name:"ModelFeatureId"`
	InstanceId     string `position:"Path" name:"InstanceId"`
}

// CreateModelFeatureTrainingSetFGTableResponse is the response struct for api CreateModelFeatureTrainingSetFGTable
type CreateModelFeatureTrainingSetFGTableResponse struct {
	*responses.BaseResponse
	RequestId              string `json:"requestId" xml:"requestId"`
	TrainingSetFGTableName string `json:"TrainingSetFGTableName" xml:"TrainingSetFGTableName"`
}

// CreateCreateModelFeatureTrainingSetFGTableRequest creates a request to invoke CreateModelFeatureTrainingSetFGTable API
func CreateCreateModelFeatureTrainingSetFGTableRequest() (request *CreateModelFeatureTrainingSetFGTableRequest) {
	request = &CreateModelFeatureTrainingSetFGTableRequest{
		RoaRequest: &requests.RoaRequest{},
	}
	request.InitWithApiInfo("PaiFeatureStore", "2023-06-21", "CreateModelFeatureTrainingSetFGTable", "/api/v1/instances/[InstanceId]/modelfeatures/[ModelFeatureId]/trainingsetfgtable", "", "")
	request.Method = requests.POST
	return
}

// CreateCreateModelFeatureTrainingSetFGTableResponse creates a response to parse from CreateModelFeatureTrainingSetFGTable response
func CreateCreateModelFeatureTrainingSetFGTableResponse() (response *CreateModelFeatureTrainingSetFGTableResponse) {
	response = &CreateModelFeatureTrainingSetFGTableResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
