package pairecservice

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// UpdateLayer invokes the pairecservice.UpdateLayer API synchronously
func (client *Client) UpdateLayer(request *UpdateLayerRequest) (response *UpdateLayerResponse, err error) {
	response = CreateUpdateLayerResponse()
	err = client.DoAction(request, response)
	return
}

// UpdateLayerWithChan invokes the pairecservice.UpdateLayer API asynchronously
func (client *Client) UpdateLayerWithChan(request *UpdateLayerRequest) (<-chan *UpdateLayerResponse, <-chan error) {
	responseChan := make(chan *UpdateLayerResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.UpdateLayer(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// UpdateLayerWithCallback invokes the pairecservice.UpdateLayer API asynchronously
func (client *Client) UpdateLayerWithCallback(request *UpdateLayerRequest, callback func(response *UpdateLayerResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *UpdateLayerResponse
		var err error
		defer close(result)
		response, err = client.UpdateLayer(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// UpdateLayerRequest is the request struct for api UpdateLayer
type UpdateLayerRequest struct {
	*requests.RoaRequest
	Body    string `position:"Body" name:"body"`
	LayerId string `position:"Path" name:"LayerId"`
}

// UpdateLayerResponse is the response struct for api UpdateLayer
type UpdateLayerResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
}

// CreateUpdateLayerRequest creates a request to invoke UpdateLayer API
func CreateUpdateLayerRequest() (request *UpdateLayerRequest) {
	request = &UpdateLayerRequest{
		RoaRequest: &requests.RoaRequest{},
	}
	request.InitWithApiInfo("PaiRecService", "2022-12-13", "UpdateLayer", "/api/v1/layers/[LayerId]", "", "")
	request.Method = requests.PUT
	return
}

// CreateUpdateLayerResponse creates a response to parse from UpdateLayer response
func CreateUpdateLayerResponse() (response *UpdateLayerResponse) {
	response = &UpdateLayerResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
