package swas_open

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// AllocatePublicConnection invokes the swas_open.AllocatePublicConnection API synchronously
func (client *Client) AllocatePublicConnection(request *AllocatePublicConnectionRequest) (response *AllocatePublicConnectionResponse, err error) {
	response = CreateAllocatePublicConnectionResponse()
	err = client.DoAction(request, response)
	return
}

// AllocatePublicConnectionWithChan invokes the swas_open.AllocatePublicConnection API asynchronously
func (client *Client) AllocatePublicConnectionWithChan(request *AllocatePublicConnectionRequest) (<-chan *AllocatePublicConnectionResponse, <-chan error) {
	responseChan := make(chan *AllocatePublicConnectionResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.AllocatePublicConnection(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// AllocatePublicConnectionWithCallback invokes the swas_open.AllocatePublicConnection API asynchronously
func (client *Client) AllocatePublicConnectionWithCallback(request *AllocatePublicConnectionRequest, callback func(response *AllocatePublicConnectionResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *AllocatePublicConnectionResponse
		var err error
		defer close(result)
		response, err = client.AllocatePublicConnection(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// AllocatePublicConnectionRequest is the request struct for api AllocatePublicConnection
type AllocatePublicConnectionRequest struct {
	*requests.RpcRequest
	ClientToken        string `position:"Query" name:"ClientToken"`
	DatabaseInstanceId string `position:"Query" name:"DatabaseInstanceId"`
}

// AllocatePublicConnectionResponse is the response struct for api AllocatePublicConnection
type AllocatePublicConnectionResponse struct {
	*responses.BaseResponse
	RequestId        string `json:"RequestId" xml:"RequestId"`
	PublicConnection string `json:"PublicConnection" xml:"PublicConnection"`
}

// CreateAllocatePublicConnectionRequest creates a request to invoke AllocatePublicConnection API
func CreateAllocatePublicConnectionRequest() (request *AllocatePublicConnectionRequest) {
	request = &AllocatePublicConnectionRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("SWAS-OPEN", "2020-06-01", "AllocatePublicConnection", "SWAS-OPEN", "openAPI")
	request.Method = requests.POST
	return
}

// CreateAllocatePublicConnectionResponse creates a response to parse from AllocatePublicConnection response
func CreateAllocatePublicConnectionResponse() (response *AllocatePublicConnectionResponse) {
	response = &AllocatePublicConnectionResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
